@REM EnableWiFiTracing.cmd v1.2
@setlocal ENABLEDELAYEDEXPANSION

@REM Debug flag to turn on echo
@if "%DBGSCRIPT%"=="" set DBGSCRIPT=0

@if %DBGSCRIPT%==0 @echo off
REM Setup redirection to suppress cmd output and expected error messages
if %DBGSCRIPT%==0 set REDIRECT=^>NUL 2^>NUL

REM This needs to run as an administrator - check for that
whoami /groups | find "S-1-16-12288" %REDIRECT%
if errorlevel 1 goto ElevationRequired

rem
rem define friendly names
rem
set WDIWIFI_WPP_GUID={21ba7b61-05f8-41f1-9048-c09493dcfe38} 0xff
set WDI_INTEL_GUID={f5a80f1a-0e52-4211-892e-9886e10f27a4}
set WDI_INTEL_SESSION=IntelNetwfw02

REM Detect if a tracing session is already running
logman query -ets | find /i "nettrace-%userdomain%-%username%" >NUL
if errorlevel 1 goto StartTracing
goto TracingInProgress

:StartTracing
REM Generate a unique suffix from timestamp
set SFX_TM=%RANDOM%
set SFX_DT=%RANDOM%
for /f "usebackq tokens=1,2 delims=: " %%i in (`time /t`) do set SFX_TM=%%i%%j
for /f "usebackq tokens=2,3,4 delims=/ " %%i in (`date /t`) do set SFX_DT=%%i-%%j-%%k
set SUFFIX=%SFX_DT%_%SFX_TM%


IF EXIST "%USERPROFILE%\Desktop\Desktop.ini" (

	set TARGETFOLDER=%USERPROFILE%\Desktop\WlanTraces\%COMPUTERNAME%-%SUFFIX%

) ELSE (

	set TARGETFOLDER=%temp%\WlanTraces\%COMPUTERNAME%-%SUFFIX%

)

md %TARGETFOLDER%

echo.
echo Traces are being stored in: %TARGETFOLDER%\
echo.

REM Enable Marvell driver and WLAN tracing

echo.
echo Enabling WiFi miniport driver tracing...
echo.
REM del %temp%\wlan*.*
netsh trace sta wireless_dbg provider=%WDIWIFI_WPP_GUID% globallevel=0xff persistent=yes trace=%TARGETFOLDER%\wlan_%computername%_%SUFFIX%.etl corr=dis ov=yes cap=yes packettruncate=200 %REDIRECT%

logman create trace autosession\mwls97w8arm -p {BFA91C93-9E18-497C-971B-490D06089E97} 0x1 255 -f bincirc -max 250 -o %TARGETFOLDER%\Marvell_%computername%_%SUFFIX%.etl %REDIRECT%
logman update trace autosession\mwls97w8arm -p {0160d072-248f-11e2-be71-082e5f28d97c} 0xFF 255 -ets %REDIRECT%
logman update trace autosession\mwls97w8arm -p {07C9AAA5-FF6B-44CF-A417-C3BE5A719C0B} 0xFF 255 -ets %REDIRECT%

logman start mwls97w8arm -p {BFA91C93-9E18-497C-971B-490D06089E97} 0x1 255 -f bincirc -max 150 -o %TARGETFOLDER%\Marvell_%computername%_%SUFFIX%.etl -ets  %REDIRECT%
logman update trace mwls97w8arm -p {0160d072-248f-11e2-be71-082e5f28d97c} 0xFF 255 -ets %REDIRECT%
logman update trace mwls97w8arm -p {07C9AAA5-FF6B-44CF-A417-C3BE5A719C0B} 0xFF 255 -ets %REDIRECT%

logman create trace autosession\qcwlan -p {BB6F5B93-635C-47BE-816F-E895E77064A8} 0xffff 18 -f bincirc -max 250 -o %TARGETFOLDER%\QCwlan_%computername%_%SUFFIX%.etl  %REDIRECT%
logman start qcwlan -p {BB6F5B93-635C-47BE-816F-E895E77064A8} 0xffff 18 -f bincirc -max 150 -o %TARGETFOLDER%\QCwlan_%computername%_%SUFFIX%.etl -ets %REDIRECT%

logman create trace autosession\bcrmwlan -p {CEA4623F-AA31-4286-B3A5-797EF8A75C17} 0xffffffff 255 -f bincirc -max 250 -o %TARGETFOLDER%\BCRMwlan_%computername%_%SUFFIX%.etl  %REDIRECT%
logman start bcrmwlan -p {CEA4623F-AA31-4286-B3A5-797EF8A75C17} 0xffffffff 255 -f bincirc -max 150 -o %TARGETFOLDER%\BCRMwlan_%computername%_%SUFFIX%.etl -ets %REDIRECT%

logman create trace autosession\%WDI_INTEL_SESSION% -p %WDI_INTEL_GUID_FLAGS% 0xffffffff 255 -f bincirc -max 250 -o %TARGETFOLDER%\%WDI_INTEL_SESSION%_%computername%_%SUFFIX%.etl  %REDIRECT%
logman start  %WDI_INTEL_SESSION% -p %WDI_INTEL_GUID% 0xffffffff 255 -f bincirc -max 150 -o %TARGETFOLDER%\%WDI_INTEL_SESSION%_%computername%_%SUFFIX%.etl -ets %REDIRECT%

netsh ras diag set tr en %REDIRECT%

REM Capturing network environment
echo      ====START==== %date% %time%  Network environment at beginning of trace ==== >> %TARGETFOLDER%\netenv.txt
netsh wlan show all >> %TARGETFOLDER%\netenv.txt
ipconfig /all >> %TARGETFOLDER%\netenv.txt

echo Wlan Service Info:>> %TARGETFOLDER%\netenv.txt
sc.exe queryex nativewifip>> %TARGETFOLDER%\netenv.txt
sc.exe qc nativewifip>> %TARGETFOLDER%\netenv.txt
sc.exe queryex wlansvc>> %TARGETFOLDER%\netenv.txt
sc.exe qc wlansvc>> %TARGETFOLDER%\netenv.txt
echo      ==TRACE_INIT== >> %TARGETFOLDER%\netenv.txt

:TracingInProgress
echo.
echo ***********************************************************
echo.
echo Please reproduce your issue and click enter when done...
echo.
echo ***********************************************************
echo.
set /p var=

REM Figure out the target folder in case we were called after a reboot
if "%TARGETFOLDER%"=="" (
	IF EXIST "%USERPROFILE%\Desktop\Desktop.ini" (
		set BASEFOLDER=%USERPROFILE%\Desktop\WlanTraces
	) ELSE (
		set BASEFOLDER=%temp%\WlanTraces
	)

	for /f "usebackq" %%i in (`dir /b %BASEFOLDER% /o-d`) do set TARGETFOLDER=%BASEFOLDER%\%%i& goto breakfor

)

:breakfor

@if %DBGSCRIPT%==1 echo !TARGETFOLDER!\netenv.txt

echo Enter a brief description of the issue (Press Enter when done):
set /p ISSUEDESCRIPTION=
echo.
echo %ISSUEDESCRIPTION% > !TARGETFOLDER!\IssueDescription.txt

echo.
echo Collecting the logs...
echo.

netsh ras diag set tr dis %REDIRECT%
logman stop mwls97w8arm -ets %REDIRECT%
logman delete autosession\mwls97w8arm %REDIRECT%
logman stop qcwlan -ets %REDIRECT%
logman delete autosession\qcwlan %REDIRECT%
logman stop bcrmwlan -ets %REDIRECT%
logman delete autosession\bcrmwlan %REDIRECT%
logman update WiFiSession -fd -ets
logman update LwtNetLog -fd -ets
netsh wlan show wlanreport

echo.
echo Please wait and do not turn off your screen - stopping traces may take a while to complete

xcopy "%SystemRoot%\System32\Winevt\Logs\System.evtx" "%TARGETFOLDER%\"  %REDIRECT%
xcopy "%SystemRoot%\livekernelreports\*.dmp" "%TARGETFOLDER%\" %REDIRECT%
xcopy "%SystemRoot%\System32\Winevt\Logs\Microsoft-Windows-WLAN-AutoConfig*Operational.evtx" "%TARGETFOLDER%\" %REDIRECT%
xcopy "%SystemRoot%\System32\Winevt\Logs\Microsoft-Windows-Dhcp*.evtx" "%TARGETFOLDER%\" %REDIRECT%
xcopy "%SystemRoot%\System32\Winevt\Logs\Microsoft-Windows-Wcmsvc*Operational.evtx" "%TARGETFOLDER%\" %REDIRECT%
xcopy "%SystemRoot%\System32\Winevt\Logs\Microsoft-Windows-NCSI*Operational.evtx" "%TARGETFOLDER%\" %REDIRECT%

xcopy "%SystemRoot%\System32\LogFiles\WMI\wifi.etl" "%TARGETFOLDER%\"  %REDIRECT%
xcopy "%SystemRoot%\System32\LogFiles\WMI\LwtNetLog.etl" "%TARGETFOLDER%\"  %REDIRECT%

xcopy "%PROGRAMDATA%\Microsoft\Windows\WlanReport\wlan-report-latest.html" "%TARGETFOLDER%\"  %REDIRECT%

REM copy /y %TARGETFOLDER%\wlan_%computername%_%SUFFIX%.etl %TARGETFOLDER%\backup-wlan_%computername%.etl %REDIRECT%
if %DBGSCRIPT%==1 logman stop nettrace-%userdomain%-%username% -ets
netsh trace stop

REM Move the nettrace ETL file if the CAB is already present
if exist "!TARGETFOLDER!\*.cab" (
for /f "usebackq" %%i in (`dir /b /s !TARGETFOLDER!\*.cab`) do call :MoveToBackup %%~dpni.etl
)
 
REM Compress driver trace files
echo Please wait - compressing trace files ...
for /f "usebackq" %%i in (`dir /s /b !TARGETFOLDER!\*.etl`) do call :MakeCabAndMoveSrcToBackup %%i
for /f "usebackq" %%i in (`dir /s /b !TARGETFOLDER!\*.dmp`) do call :MakeCabAndMoveSrcToBackup %%i
for /f "usebackq" %%i in (`dir /s /b !TARGETFOLDER!\*.html`) do call :MakeCabAndMoveSrcToBackup %%i

REM Capturing network environment
echo      ==TRACE_STOP== %date% %time%  Network environment at end of trace >> !TARGETFOLDER!\netenv.txt
netsh wlan show all >> !TARGETFOLDER!\netenv.txt
ipconfig /all >> !TARGETFOLDER!\netenv.txt
echo      ====END====   =============================================== >> !TARGETFOLDER!\netenv.txt

REM Collect RAS log files
copy /y %windir%\tracing\explorer*.log !TARGETFOLDER! %REDIRECT%
copy /y %windir%\tracing\svchost*.log !TARGETFOLDER! %REDIRECT%

echo.
echo.
echo.
echo.
echo ***********************************************************
echo.
echo Capture completed!
call %~dp0\UploadWlanTraces.cmd /silent
if errorlevel 2 goto ManualCopyNeeded
echo.
echo WLAN trace logs have been successfully uploaded.
echo.
echo Please send email with the computer name to 
echo wifitri@microsoft.com request an investigation
echo.
echo ***********************************************************
echo.
color A
pause
color
REM Attempt to refresh scripts in case they were copied down by UploadWlanTraces
start /MIN xcopy /y /d %temp%\WlanTraceScripts\*.* %~dp0 %REDIRECT%
goto :eof

:ManualCopyNeeded
echo.
echo Please connect to Microsoft corp-net and run UploadWlanTraces.cmd to 
echo upload the log files.
echo If corp-net connectivity is unavailable, email the recent log files at
echo.
echo     !TARGETFOLDER!\*.* & start !TARGETFOLDER! & goto breakfor2
:breakfor2
echo.
echo to wifitri@microsoft.com request an investigation
echo.
echo ***********************************************************
echo.
color C
pause
color
REM Attempt to refresh scripts in case they were copied down by UploadWlanTraces from a previous session
start /MIN xcopy /y /d %temp%\WlanTraceScripts\*.* %~dp0 %REDIRECT%
goto :eof

REM Subroutine to compress file
:MakeCabAndMoveSrcToBackup
if "%1" NEQ "" (
REM echo makecab.exe %1 %~dpn1.cab
makecab.exe %1 %~dpn1.cab %REDIRECT%
if not errorlevel 1 (
if exist %~dpn1.cab (
call :MoveToBackup %1
)
)
)
goto :eof

:MoveToBackup
if not exist %temp%\WlanTraces-backup md %temp%\WlanTraces-backup %REDIRECT%
move /y %1 %temp%\WlanTraces-backup %REDIRECT%
goto :eof

:ElevationRequired
color c
echo.
echo ***********************************************************
echo Enabling tracing requires administrator privileges. Please
echo run this in an elevated cmd window.
echo ***********************************************************
echo.
set /p var=
color
goto :eof

:eof
endlocal
